Attribute VB_Name = "Library"
'-------------  toc functions -----------------------------

Public Sub SaveTocChanges(lv As ListView, l As listStyle)
    Dim tmp()
    v = Chr(5)
    
    'On Error Resume Next
    
    Dim rs As Recordset
    Dim li As ListItem
    
    cn.Execute "Delete from tblToc where box=" & l
    
    With lv.ListItems
        For i = 1 To .Count
           Set li = .Item(i)
           
           li.SubItems(1) = Replace(li.SubItems(1), "'", Empty)
           li.SubItems(2) = Replace(li.SubItems(2), "'", Empty)
              
           sql = "Insert into tblToc (read,fromuser,subject,path,box) VALUES('" & li.Text & _
                "','" & li.SubItems(1) & "','" & li.SubItems(2) & "','" & li.key & "'," & l & ")"
        
           cn.Execute sql
        Next
    End With
    
End Sub

Public Function getTocPath(style As listStyle, Optional topLevel = True)
    
    Dim box As String, toc As String
    Select Case style
        Case inbox
             box = endSlash(uc.folders.inbox)
             toc = box & "inbox.toc"
        Case outbx
             box = endSlash(uc.folders.oubox)
             toc = box & "outbox.toc"
        Case trash
             box = endSlash(uc.folders.trash)
             toc = box & "trash.toc"
        Case saved
             box = endSlash(uc.folders.saved)
             toc = box & "saved.toc"
    End Select
    
    If Not fso.FolderExists(box) Then fso.buildPath (box)
    If fso.FileExists(toc) And topLevel Then Import_oldTOC style
    
    getTocPath = toc
    
End Function

Sub RebuildTocFromFiles(lv As ListView, box As listStyle)
  On Error GoTo out
    lv.ListItems.Clear
    toc = Library.getTocPath(box)
    If fso.FileExists(toc) Then Kill toc
    pf = fso.GetParentFolder(toc)
    Dim dc As DirectoryContents
    dc = fso.GetDirContents(pf, "txt")
    Dim fnames() As String
    ReDim fnames(1 To dc.sFiles.Count)
    For i = 1 To dc.sFiles.Count
        fnames(i) = CStr(pf & dc.sFiles(i))
    Next
    FillBox lv, fnames()
    Call SaveTocChanges(lv, box)
    Exit Sub
out: MsgBox "There are no files in this folder", vbInformation
End Sub

Public Function loadTOC(l As ListView, it As listStyle)
    Dim rs As Recordset
    Dim li As ListItem
    
    toc = Library.getTocPath(it) 'preforms import to new db format if not already
    
    Set rs = cn.Execute("Select * from tblTOC where box=" & it & " order by autoid asc")
    With l.ListItems
        While Not rs.EOF
            Set li = .Add(, rs!path, rs!read)
            li.SubItems(1) = rs!fromuser
            li.SubItems(2) = rs!subject
            rs.MoveNext
        Wend
    End With
    
End Function

Public Function Import_oldTOC(it As listStyle)
  Dim sql As String
  
    toc = Library.getTocPath(it, False)
    info = fso.readFile(toc)
    info = Split(info, vbCrLf)
      
    For i = 0 To UBound(info)
        info(i) = Replace(info(i), "'", Empty)
        Sect = Split(info(i), Chr(5))
        If UBound(Sect) = 3 Then
          
            sql = "Insert into tblToc (read,fromuser,subject,path,box) VALUES('" & Sect(0) & _
                    "','" & Sect(1) & "','" & Sect(2) & "','" & Sect(3) & "'," & it & ")"
            
            cn.Execute sql
                       
        End If
    Next

    On Error Resume Next
    fso.Delete toc

End Function


'-------------------------------------------------------------
Public Sub checkMail(userIndex As Integer, Optional debugmode As Boolean = False, Optional hidden = False)
  On Error GoTo warn
    Dim msg() As String 'checkmail returns base 1 array
    
    If userIndex = UBound(uc.Users) Then
        For i = 1 To UBound(uc.Users) - 1
            With uc.Users(i)
                msg() = frmCheckMail.getMail(.Server, .user, .pass, .port, debugmode, hidden)
            End With
            FillBox frmMessages.lv(1), msg(), True
        Next
    Else
        With uc.Users(userIndex)
                msg() = frmCheckMail.getMail(.Server, .user, .pass, .port, debugmode, hidden)
        End With
        FillBox frmMessages.lv(1), msg(), True
    End If
    
Exit Sub
warn: MsgBox "err in checkmail() " & Err.Description & Err.Source
End Sub

Public Sub FillBox(lv As ListView, msg() As String, Optional addNew As Boolean = False)
    
    If AryIsEmpty(msg) Then Exit Sub
    
    Dim Outbox As Boolean, t
    Dim l As listStyle
    l = inbox
    
    If lv.ColumnHeaders(2).Text = "To:" Then Outbox = True
    
    For j = 1 To UBound(msg)
       Dim p As parsed
       p = parseMail(GetMailHeader(msg(j)))
       If Outbox Then t = "?" Else t = IIf(p.atch = 0, "<>", "<A>")
       With lv.ListItems
          i = .Count + 1
          .Add i, msg(j), t
          If Outbox Then .Item(i).SubItems(1) = p.to _
          Else .Item(i).SubItems(1) = p.from
          .Item(i).SubItems(2) = p.subj
       End With
       If addNew Then
            
            t = Replace(t, "'", Empty)
            p.from = Replace(p.from, "'", Empty)
            p.subj = Replace(p.subj, "'", Empty)
        
            sql = "Insert into tblToc (read,fromuser,subject,path,box) VALUES('" & t & _
            "','" & p.from & "','" & p.subj & "','" & msg(j) & "'," & l & ")"
    
            cn.Execute sql
       End If
    Next
    
End Sub

Public Sub saveSent(msg As String, Optional Qued As Boolean = False)
     Dim p As parsed, q As String
     Dim l As listStyle
     l = outbx
     
     p = parseMail(msg)
     toc = getTocPath(outbx)
     tf = fso.CreateTempFile(fso.GetParentFolder(toc), ".txt")
     fso.writeFile tf, msg
     If Qued Then q = "Q" Else q = "S"
     With frmMessages.lv(2).ListItems
        i = .Count + 1
        .Add i, tf, q
        .Item(i).SubItems(1) = p.to
        .Item(i).SubItems(2) = p.subj
     End With
     
    q = Replace(q, "'", Empty)
    p.to = Replace(p.to, "'", Empty)
    p.subj = Replace(p.subj, "'", Empty)
            
    sql = "Insert into tblToc (read,fromuser,subject,path,box) VALUES('" & q & _
            "','" & p.to & "','" & p.subj & "','" & tf & "'," & l & ")"
    
    cn.Execute sql

     
     
End Sub



Public Sub ComposeNewMail(Optional recpt = "", Optional subject = "", Optional body = "", Optional from = "")
    Dim frmD As frmCompose
    Set frmD = New frmCompose
    frmD.Caption = ""
    If Len(from) = 0 Then
        frmD.cboFrom.Text = uc.Send.sender(uc.Send.default)
    Else
        frmD.cboFrom.Text = from
    End If
    frmD.txtProps(1) = recpt
    frmD.txtProps(2) = subject
    frmD.txtMsg = Replace(body, vbCrLf & "." & vbCrLf, vbCrLf)
    frmD.Show
    Set frmD = Nothing
End Sub

Public Sub EmptyTrash()
    Call fso.DeleteFolder(uc.folders.trash, True)
    Call Library.getTocPath(trash)
    Dim l As listStyle
    l = trash
    cn.Execute "Delete from tbltoc where box=" & l
End Sub

Function GetMailHeader(path)
  On Error GoTo out
    tmp = ""
    If FileLen(path) < 10 Then Exit Function
    f = FreeFile
    Open path For Input As f
    While Right(tmp, 4) <> vbCrLf & vbCrLf
       Line Input #f, it
       tmp = tmp & it & vbCrLf
    Wend
    Close #f
out:
    GetMailHeader = tmp
End Function

Public Function parseMail(msg) As parsed
    On Error Resume Next
    Dim p As parsed
    p.body = msg
    p.atch = 0
    If InStr(p.body, "boundary=""") > 0 Then p.atch = 1
    tmp = Split(msg, vbCrLf)
      
      For j = 0 To UBound(tmp)
          col = InStr(1, tmp(j), ":") + 1
          
          If InStr(1, Left(tmp(j), 7), "From", vbTextCompare) > 0 Then
              p.from = Trim(Mid(tmp(j), col, Len(tmp(j))))
          End If
            
          If InStr(1, Left(tmp(j), 9), "Subject", vbTextCompare) > 0 Then
              p.subj = Trim(Mid(tmp(j), col, Len(tmp(j))))
          End If
          
          If InStr(1, Left(tmp(j), 5), "To", vbTextCompare) > 0 Then
              p.to = Trim(Mid(tmp(j), col, Len(tmp(j))))
          End If
          
          If p.from <> "" And p.subj <> "" And p.to <> "" Then Exit For
      Next
    
      parseMail = p
End Function

Function MonitorClipboard() As String
    X = FirstLine(LTrim(Trim(Clipboard.GetText)))
    If InStr(X, "@") > 0 Then
        sp = InStr(2, X, " ")
        If sp > 0 Then MonitorClipboard = Mid(X, 1, sp - 1) _
        Else MonitorClipboard = CStr(X)
    End If
End Function



Function DeQuote(it)
  On Error GoTo out
    Dim f(): Dim c()
    n = it
    If InStr(n, "=") > 0 Then
        t = Split(n, "=")
        For i = 0 To UBound(t)
            a = Left(t(i), 2)
            b = IsHex(a)
            If b <> Empty Then
                push f(), "=" & a
                push c(), b
            End If
        Next
        If Not AryIsEmpty(f) Then
            For i = 0 To UBound(f): n = Replace(n, f(i), c(i)): Next
        End If
        n = Replace(n, "=" & vbCrLf, "")
    End If
    DeQuote = n
Exit Function
out: DeQuote = it: MsgBox Err.Description, vbCritical, "Err in deQuote"
End Function

Function Escape(it)
    Dim f(): Dim c()
    n = Replace(it, "+", " ")
    If InStr(n, "%") > 0 Then
        t = Split(n, "%")
        For i = 0 To UBound(t)
            a = Left(t(i), 2)
            b = IsHex(a)
            If b <> Empty Then
                push f(), "%" & a
                push c(), b
            End If
        Next
        For i = 0 To UBound(f)
            n = Replace(n, f(i), c(i))
        Next
    End If
    Escape = n
End Function

Public Function breakIt(it)
    breakIt = uc.Prefs.ReplyChar & Replace(it, vbCrLf, vbCrLf & uc.Prefs.ReplyChar)
End Function

Sub ParseCommandLine(arg)
    Dim t() As String
    arg = BatchReplace(arg, """-,?-&,mailto:-")
    t = Split(arg, "&")
    subj = Escape(StrFindValFromKey(t, "subject"))
    body = Escape(StrFindValFromKey(t, "body"))
    Call ComposeNewMail(t(0), subj, body)
End Sub
